

/*#######################################################################################



AVR DCF77 Clock 
//GETESTED NUR mit ATMEGA16

ERFAHRUNGEN : EXTREM Schlechtes Modul von Pollin,
deshab Interrupts zufuss etwas Debounced...

Copyright (C) 2005 Ulrich Radig, 
modifiziert/angepasst Christof Ermer Regensburg 4.2010

http://www.mikrocontroller.net/topic/101487
 Es kann entweder 100ms Low und 900ms High sein oder auch umgekehrt.
Nach meinem Verstndnis erwartet der Prozessor lange Low und kurze Highs (100ms,200ms).
#######################################################################################*/

/*
// IMMER include <avr\interrupt.h> einbinden, sonnjst gibt probleme... 
// ISR( xx )  wird sonst  einfach weggelassen/rausoptimiert.

Variablen, die sowohl in Interrupts als auch im
Hauptprogramm verwendet werden, mssen "volatile" sein.

volatile bedeutet, dass die Variable immer nach Vernderung sofort an
deren Speicherstelle im Ram rckgeschrieben werden muss und nicht noch
fr eine bestimmte Zeit in einem Register "geparkt" werden darf.
*/



// ZUERST ANPASSUNG AN DIE VERWENDETE HARDWARE
//WEGEN DEM SEKUNDEN BEEP
#define POLLIN_DCF // USER BESTIMMTE HARDWARE SELBST ANPASSEN
#define POLLIN_EVALBOARD // USER BESTIMMTE HARDWARE SELBST ANPASSEN
#define DELAY_INT_WIEDER_ON 12U

#include <ctype.h>
#include <inttypes.h>
#include <stdio.h>
#include <stdlib.h>
#include <avr/io.h>
#include <avr\interrupt.h>

#include <string.h>
#include <avr\pgmspace.h> // <--#include <progmem.h>

#include <math.h>
//#include <stdlib.h>

#include "uart.h"
#include "clock.h"
#include <util\delay.h>	//_delay_loop_1 _delay_loop_2 delay_ms

static char gcaStr[ 81 ];
/*
Variablen, die sowohl in Interrupts als auch im
Hauptprogramm verwendet werden, mssen "volatile" sein.
*/
volatile uint32_t gu32_Ticks;
//Prototypen
void StartTickTimer(void);
#ifdef POLLIN_EVALBOARD
void Plip(uint8_t u8ZZ); // Nur fr Pollin Eval bord
#endif


// ************************************************
ISR( TIMER2_OVF_vect ) // mit sei() am Anfang
// ************************************************
{
sei();
gu32_Ticks++;
};



///TIMER
#define TIFR_TOV0_TIMER_OVERFLOW_FLAG	0x01
#define TIFR_OCF0_OUT_PCOMPARE_FLAG		0x02
#define TIFR_TOV1_TIMER_OVERFLOW_FLAG	0x04
#define TIFR_OCF1A_OUTP_COMPARE_A_FLAG	0x10
#define TIFR_OCF1B_OUTP_COMPARE_B_FLAG	0x08
#define TIFR_TOV2_TIMER_OVERFLOW_FLAG	0x40
#define TIFR_OCF2_OUTP_COMPARE_FLAG		0x80

#define TIMSK_TOIE0_FLAG	0x01
#define TIMSK_OCIE0_FLAG	0x02
#define TIMSK_TOIE1_FLAG	0x04
#define TIMSK_OCIE1B_FLAG	0x08
#define TIMSK_OCIE1A_FLAG	0x10
#define TIMSK_TICIE1_FLAG	0x20
#define TIMSK_TOIE2_FLAG	0x40	//#define TOIE2 6     (1 << TOIE2)
#define TIMSK_OCIE2_FLAG	0x80

#define TIMSK_T0_CLR_ALL_MASK 0b11111100
#define TIMSK_T1_CLR_ALL_MASK 0b11000011
#define TIMSK_T2_CLR_ALL_MASK 0b00111111
#define TCCR2_WGM_NORMAL		0x00
#define TCCR2_CTC_MODE			0x08 //0000 1000
#define TCCR2_COM_NORMALPORT	0x00
#define TCCR2_CLK_STOP			0x00
#define TCCR2_FASTPWM			0x48	//Mode 3
#define TCCR2_CS_BIST			0x0x	//Mode 3
#define TCCR2_CLK_1024	0x07	
#define TCCR2_CLK_256	0x06	
#define TCCR2_CLK_128	0x05
#define TCCR2_CLK_64	0x04	//
#define TCCR2_CLK_32	0x03
#define TCCR2_CLK_8		0x02	//	1/F = 
#define TCCR2_CLK_0		0x01	
#define TCCR2_CLK_STOP	0x00	

// *************************************
void StartTickTimer(void)	//0.1 Seconds  interrupt
// *************************************
{
uint8_t u8sreg;
u8sreg = SREG; //loakaler Speicher
cli();
TIMSK &=  ~( _BV(TOIE2) | _BV(OCIE2) );
//TIFR |= TIFR_OCF2_OUTP_COMPARE_FLAG | TIFR_TOV2_TIMER_OVERFLOW_FLAG ; // zum lschen setzen!
//TIMER STARTS with Presscale Select = 64
TCNT2 = 0; 
TIMSK |= _BV(TOIE2); //TIMSK_TOIE2_FLAG; //_BV(TOIE2); // BESSER == OVERFLOW 
//TCCR2 = TCCR2_CLK_0;	//
TCCR2 = 0x06; //TCCR2_CLK_256;	//Timer Counter CTRL -- NORMAL MODE=NO OCR2
SREG  = u8sreg;
sei();
};

#ifdef POLLIN_EVALBOARD
// *************************************
void Plip(uint8_t u8ZZ)
// *************************************
{
uint8_t u8NN;
DDRD |= 0x80; //WEGEN SUMMER
PORTD |= 0x80; //SUMMER
for(u8NN=0; u8NN < u8ZZ;u8NN++)
	{
	_delay_ms(1);
	};
PORTD &= 0x7F;
};
#endif

//############################################################################
//Hauptprogramm
int main (void)
//############################################################################
{

//uint8_t u8NN;
static volatile uint32_t u32Now;
DDRD = 0b0000110; //TX vom UART und PON

// ------------------- 
//Analog Comaprator Interrupt dissable
//Analog Comaprator Interrupt FLAG dissable
ACSR &= ~(_BV(ACIE) | _BV(ACI));	//Analog Comaprator Interrupt dissable
ACSR |= _BV(ACD);  		//Analog Comparator PWR Disable 
// ------------------- 

	//Inizialisierung der Seriellen Schnittstelle
	uart_init( UART_BAUD_SELECT(9600, F_CPU) );
	sei();
	//Globale Interrupts einschalten
	PORTA = TIMSK;
	PORTB = TIFR;

	StartTickTimer();	

	//Starten der DCF77 Uhr
	Start_Clock();

	sprintf(gcaStr, "\nDCF 77 Clock org. by Ulrich Radig, mod by. Christof Ermer\n\r" );
	uart_puts( gcaStr );
  
	gu32_Ticks = u32Now = 0;
	//Wait a schort time
	
#ifdef POLLIN_EVALBOARD // USER BESTIMMTE HARDWARE SELBST ANPASSEN
DDRC = 0xFF; //TEST LED LEISTE
#endif

for(;;)
	{
	sei();	

#ifdef POLLIN_EVALBOARD // USER BESTIMMTE HARDWARE SELBST ANPASSEN
PORTC = gu8InterruptStatus; //TEST LED LEISTE
#endif
	// Weils nur rger gab mit dem schelchtejn Signal wird der INterruppt 
	// abgeschaltet ne Zeitlang.
	if( gu8InterruptStatus & INTERRUPTSTATUS_EVENT  )
		{
		DCF77_INT_DISABLE();	//GICR &= ~(1<<INT1);
		GIFR = (1<< INTF1); // lsche alle INT Ereignisse // Siehe pdf
		if( gu8InterruptStatus & INTERRUPTSTATUS_RISING_INT )
			{
			#ifdef POLLIN_EVALBOARD
			Plip(1);		
			#endif
		sprintf(gcaStr, "DMY:%i-%i-%i Time: %i:%i:%i Sync: %i  Rx: %i      \r",
				day,mon,year,hh,mm,ss,flags.dcf_sync,flags.dcf_rx);
		uart_puts( gcaStr );
			};
		
		gu8InterruptStatus = INTERRUPTSTATUS_DISABLED;
		gu32InterruptTime = gu32_Ticks; 
		};
	
	if( gu8InterruptStatus == INTERRUPTSTATUS_DISABLED )
		{
		if( (gu32_Ticks) >=  (gu32InterruptTime + DELAY_INT_WIEDER_ON) )
			{
			//244 Ticks/Sekunde ind 24 pro 100MS
			//Weil da sSignal so schlecht ist.... einfahc unerwnschte sausspreren
			GIFR = (1<< INTF1); // lsche alle INT Ereignisse // Siehe pdf
			gu8InterruptStatus = 0;
			DCF77_INT_ENABLE(); // INT Wieder einschalten nach eine rguten Zeit 
			};
		};
		
	
	if( gu8InterruptStatus & INTERRUPTSTATUS_SYNC )
		{
		gu8InterruptStatus &= ~INTERRUPTSTATUS_SYNC;
		#ifdef POLLIN_EVALBOARD
		Plip(50);		
		#endif
		};
	if( gu32_Ticks > (u32Now + (244U)) )		//So ne Art Sekundenausgabemgl.		
		{
		u32Now = gu32_Ticks;	
/* TEST ZEUGS
	uart_puts_p(PSTR("TIMSK=")); sprintf(gcaStr,"%x\r", TIMSK); uart_puts(gcaStr);
	uart_puts_p(PSTR("TIFR=")); sprintf(gcaStr,"%x\r", TIFR); uart_puts(gcaStr);
	uart_puts_p(PSTR("TCNT0=")); sprintf(gcaStr,"%x\r",TCNT0); uart_puts(gcaStr);
	uart_puts_p(PSTR("OCR0="));  sprintf(gcaStr,"%x\r",OCR0); uart_puts(gcaStr);
	uart_puts_p(PSTR("TCNT1=")); sprintf(gcaStr,"%x\r",TCNT1); uart_puts(gcaStr);
	uart_puts_p(PSTR("OCR1A=")); sprintf(gcaStr,"%x\r",OCR1A); uart_puts(gcaStr);
	uart_puts_p(PSTR("OCR1B=")); sprintf(gcaStr,"%x\r",OCR1B); uart_puts(gcaStr);
	uart_puts_p(PSTR("TCNT2=")); sprintf(gcaStr,"%x\r",TCNT2); uart_puts(gcaStr);
	uart_puts_p(PSTR("OCR2=")); sprintf(gcaStr,"%x\r",OCR2); uart_puts(gcaStr);	
	//uart_putc( 13 );
*/
		};
	};
return 1;
};